<?php
/**
 * Xoops template hack class (PHP5)
 * 
 * @copyright      RB Lin (xtheme@gmail.com>
 * @license        WTFPL Version 2 - http://sam.zoy.org/wtfpl/
 * @author         RB Lin (xtheme@gmail.com>
 * @url            http://code.google.com/p/xoops-rb-framework/
 * @version        0.1
 */
 
defined('XOOPS_ROOT_PATH') or die('Restricted access');
define('FRAMEWORKS_URL', XOOPS_URL.'/Frameworks');

require_once XOOPS_ROOT_PATH.'/class/template.php';

class RbTpl
{
	var $xoopsTpl;
	var $_baseurl = FRAMEWORKS_URL;
	var $_library = 'jquery';
	var $_target = 'xoops_module_header';
	var $_attributes = array();
	
	function __construct($baseurl = '', $library = '', $target = '')
	{
		global $xoopsTpl;
		$this->xoopsTpl = (is_object($xoopsTpl) && is_a($xoopsTpl, 'XoopsTpl')) ? $xoopsTpl : new XoopsTpl();
		$this->setBaseUrl($baseurl);
		$this->setLibrary($library);
		$this->setTarget($target);
	}
	
	function RbTpl($baseurl = '', $library = '', $target = '')
	{
		$this->__construct($baseurl, $library, $target);
	}
	
	function setBaseUrl($baseurl = '')
	{
		if ($baseurl != '') $this->_baseurl = $baseurl;
		return $this;
	}
	
	function setLibrary($library = '')
	{
		if ($library != '') $this->_library = $library;
		return $this->loadLibrary($this->_library);
	}
	
	function loadLibrary($library)
	{
		$library = strtolower($library);
		switch ($library) {
			case 'jquery':
				$str = initJQuery();
				break;
		}
		return $this->writeJs($str);
	}
	
	function setTarget($target = '')
	{
		if ($target != '') $this->_target = $target;
		return $this;
	}
	
	function getTarget($target = '')
	{
		if ($target != '') $this->_target = $target;
		$val = $this->xoopsTpl->get_template_vars($this->_target);
		return $val;
	}
	
	function setMrta($tag = '', $val = '')
	{
		return $this;
	}
	
	function checkUrl($url)
	{
		if (substr($url, 0, 7) != 'http://') {
			if (substr($url, 0, 1) != '/') $url = '/'.$url;
			$url = $this->_baseurl.$url;
		}
		$fp = @fopen($url, 'r');
		if ($fp === false) return false;
		return $url;
	}
	
	function setAttr($attr = array())
	{
		$this->_attributes[] = $attr;
	}
	
	function renderAttr($attr)
	{
		$str = '';
		foreach ($attr as $name => $val) {
			if ($name != 'mode' && $name != '>_<' && $val != '') {
				$str .= sprintf(' %s="%s"', $name, htmlspecialchars($val, ENT_QUOTES));
			}
		}
		return $str;
	}
	
	function addScript($src = '', $attr = array(), $text = '')
	{
		$attr = !empty($attr) ? $attr : array();
		$attr['mode'] = 'js';
		$attr['type'] = !isset($attr['type']) ? 'text/javascript' : $attr['type'];
		$attr['src']  = !empty($src) ? $this->checkUrl($src) : '';
		$attr['>_<'] = !empty($text) ? $text : '';
		if ($attr['src'] || $attr['>_<'])
		$this->setAttr($attr);
		return $this;
	}
	
		function loadJs($url = '', $attr = array())
		{
			return $this->addScript($url, $attr);
		}
		
		function writeJs($text = '', $attr = array())
		{
			return $this->addScript('', $attr, $text);
		}

	
	function addStylesheet($href = '', $attr = array(), $text = '')
	{
		$attr = !empty($attr) ? $attr : array();
		$attr['mode'] = 'css';
		$attr['type'] = !isset($attr['type']) ? 'text/css' : $attr['type'];
		$attr['href'] = !empty($href) ? $this->checkUrl($href) : '';
		$attr['>_<'] = !empty($text) ? $text : '';
		if ($attr['href'] || $attr['>_<'])
		$this->setAttr($attr);
		return $this;
	}
	
		function loadCss($url = '', $attr = array())
		{
			return $this->addStylesheet($url, $attr);
		}
		
		function writeCss($text = '', $attr = array())
		{
			return $this->addStylesheet('', $attr, $text);
		}
	
	function back($target = '')
	{
		$this->rewrite();
		$object =& new RbTpl();
		$this->setTarget($target);
		return $object;
	}
	
	function rewrite($interpolate = 'after')
	{
		$target = $this->_target;
		$present = $this->xoopsTpl->get_template_vars($target);
		$insert = "<!-- RB rewrite -->\n";
		foreach ($this->_attributes as $attr)
		{
			switch ($attr['mode'])
			{
				case 'js':
					$insert .= '<script'.$this->renderAttr($attr).'>';
					if (!empty($attr['>_<'])) {
						$insert .= "\n//<![CDATA[\n".$attr['>_<']."\n//]]>\n";
					}
					$insert .= "</script>\n";
					break;
					
				case 'css':
					if (!empty($attr['>_<'])) {
						$insert .= "<style".$this->renderAttr($attr).">\n/* <![CDATA[ */\n" . $attr['>_<'] . "\n/* //]]> */\n</style>";
					} else {
						$insert .= '<link rel="stylesheet"'.$this->renderAttr($attr)." />\n";
					}
					break;
			}
		}
		
		switch ($interpolate)
		{
			case 'after':   $content = $present ."\n". $insert; break;	
			case 'before':  $content = $insert ."\n". $present; break;
			case 'replace': $content = $insert; break;
		}
		
		$this->xoopsTpl->assign($target, $content);
	}
}

/* 
 * Load jQuery Dynamically 
 * http://weblogs.asp.net/joelvarty/archive/2009/05/07/load-jquery-dynamically.aspx
 */
function initJQuery() {
$str = 'var jQueryScriptOutputted = false;
function initJQuery() {
	//if the jQuery object isn\'t available
	if (typeof(jQuery) == \'undefined\') {
		if (!jQueryScriptOutputted) {
			//only output the script once..
			jQueryScriptOutputted = true;
			//output the script (load it from google api)
			document.write("<scr" + "ipt type=\"text/javascript\" src=\"http://ajax.googleapis.com/ajax/libs/jquery/1.3.2/jquery.min.js\"></scr" + "ipt>");
		}
		setTimeout("initJQuery()", 50);
	} else {
		$(function() {
			//do anything that needs to be done on document.ready
			if (jQueryScriptOutputted) {
				alert("load ok");
			} else {
				alert("had");
			}
		});
	}
}
initJQuery();';
return $str;
}
?>