<?php

if (!defined('RBF_FUNC_ADD')):

define('RBF_FUNC_ADD', true);

function rb_add_attr($attr)
{
	$str = '';
	foreach ($attr as $name => $val) {
		if ($name != '_') $str .= $name.'="'.htmlspecialchars($val, ENT_QUOTES).'"';
	}
	return $str;
}
	
function rb_add_url($url)
{
	if (substr($url, 0, 7) == 'http://') return $url;
	if (substr($url, 0, 1) != '/') $url = $url.'/';
	$url = XOOPS_URL.$url;
	return $url;
}
	
function rb_add_script($src = '', $attr = array(), $content = '')
{
	if (!rb_need_compatible()) {
		global $xoTheme;
		if (empty($src)) $src = null;
		if (empty($attr)) $attr = array('type' => 'application/x-javascript');
		$xoTheme->addScript($src, $attr, $content);
	} else {
		if (empty($attr))     		$attr = array();
		if (!isset($attr['type'])) 	$attr['type'] = 'text/javascript';
		if (!empty($src) ) 			$attr['src'] = rb_add_url($src);
		if (!empty($content))		$attr['_'] = $content;
		$str = '<script '.rb_add_attr($attr).'>';
		if (@$attr['_']) {
			$str .= "\n//<![CDATA[\n".$attr['_']."\n//]]>\n";
		}
		$str .= '</script>';
		rb_smarty_assign($str);
	}
}
	
	
function rb_add_stylesheet($src = '', $attr = array(), $content = '')
{
	if (empty($attr))     		$attr = array();
	if (!isset($attr['type'])) 	$attr['type'] = 'text/css';
	if (!rb_need_compatible()) {
		global $xoTheme;
		$xoTheme->addStylesheet($src, $attr, $content);
	} else {
		if (!empty($src)) 		$attr['href'] = rb_add_url($src);
		if (!empty($content)) 	$attr['_'] = $content;
			
		if (@$attr['_']) {
			$str = "<style ".rb_add_attr($attr).">\n/* <![CDATA[ */\n" . $attr['_'] . "\n/* //]]> */\n</style>";
		} else {
			$str = '<link rel="stylesheet" '.rb_add_attr($attr).' />';
		}
		rb_smarty_assign($str);
	}
}


function rb_smarty_assign($add_value, $var = 'xoops_module_header')
{
	global $xoopsTpl;
	
	if (!class_exists('XoopsTpl')) {
		require_once XOOPS_ROOT_PATH.'/class/template.php';
		$XoopsTpl =& new XoopsTpl();
	}
	
	if ($XoopsTpl->get_template_vars($var) === null) {
		trigger_error('Smarty variable '.$var.' is not assigned or null', E_USER_NOTICE);
	} else {
		$var_value = $xoopsTpl->get_template_vars($var) ;
		$xoopsTpl->assign($var, $var_value."\n".$add_value);
	}
}

function rb_init_library($library = 'jquery')
{
	$library = strtolower($library);
	switch ($library) {
		case 'jquery':
		/*
			var jQueryScriptOutputted = false;
function initJQuery() {
    
    //if the jQuery object isn't available
    if (typeof(jQuery) == 'undefined') {
    
    
        if (! jQueryScriptOutputted) {
            //only output the script once..
            jQueryScriptOutputted = true;
            
            //output the script (load it from google api)
            document.write("<scr" + "ipt type=\"text/javascript\" src=\"http://ajax.googleapis.com/ajax/libs/jquery/1.3.2/jquery.min.js\"></scr" + "ipt>");
        }
        setTimeout("initJQuery()", 50);
    } else {
                        
        $(function() {  
            //do anything that needs to be done on document.ready
        });
    }
            
}

initJQuery();
*/
			break;
	}
	
}

endif;
?>