<?php

if (!defined('RBF_FUNC_FORMAT')):

define('RBF_FUNC_FORMAT', true);

rb_load_language('format');

// quick assign page templates name
function rb_get_pagetpl($action = '')
{
	global $xoopsModule;
	if (is_object($xoopsModule) && ($xoopsModule->getVar('dirname') != 'system')) {
		$page = basename($_SERVER['SCRIPT_NAME'], '.php');
		if ($action) $page = $page.'_'.$action;
		return $xoopsModule->getVar('dirname').'_'.$page.'.html';
	}
}

// WYSIWYG output format
function rb_format_html($text, $html = 0, $smiley = 1, $xcode = 1, $image = 1, $br = 1)
{
	$myts =& MyTextSanitizer::getInstance();
	$text = $myts->displayTarea($text, 1, 0, 0, 1, 0);
	return $text;
}

// join ($_POST, $_GET) params
function rb_format_url($add_params=array(), $url='') 
{
	$str_params = array();
	foreach ($add_params as $key => $val) {
		if( ($key == 'x') || ($key == 'y') || ($key == 'start')) continue;
		if( !empty($val) ) {
			if (is_array($val)) {
				foreach ($val as $k => $v) {
					$str_params[] = sprintf('%s[]=%s', $key, $v);
				}
			} else {
				$str_params[] = sprintf('%s=%s', $key, $val);
			}
		}
	}
	$request_url = sprintf('%s', implode('&', $str_params));
	if ($url) {
		$request_url = sprintf('%s?%s', $url, $request_url);
	}

	return $request_url;
}

function rb_nicetime($time, $str = false)
{
	if(empty($time)) {
		return RBF_FORMAT_NODATE;
	}
	
	$unix_time = ($str) ? strtotime($time) : $time;
	$periods   = array(RBF_FORMAT_SECOND, RBF_FORMAT_MINUTE, RBF_FORMAT_HOUR, RBF_FORMAT_DAY, RBF_FORMAT_WEEK, RBF_FORMAT_MONTH, RBF_FORMAT_YEAD);
	$lengths   = array('60', '60', '24', '7', '4.35', '12');
	$now       = time();
    
	// check validity of date
	if(empty($unix_time)) {
		return RBF_FORMAT_BADDATE;
	}
	
	// is it future date or past date
	if($now > $unix_time) {
		$difference    = $now - $unix_time;
		$tense         = RBF_FORMAT_AGO;
	} else {
		$difference    = $unix_time - $now;
		$tense         = RBF_FORMAT_LATER;
	}
	
	for($j = 0; $difference >= $lengths[$j] && $j < count($lengths)-1; $j++) {
		$difference /= $lengths[$j];
	}
	
	$difference = round($difference);
	
	if($difference != 1) {
		$periods[$j].= RBF_FORMAT_PLURAL;
	}
	if($difference == 0) {
		return RBF_FORMAT_NOW;
	}
	return "$difference $periods[$j]{$tense}";
}

function rb_json_encode($arr) {
	if(function_exists('json_encode')) return json_encode($arr); //Lastest versions of PHP already has this functionality.
	$parts = array();
	$is_list = false;
	
	//Find out if the given array is a numerical array
	$keys = array_keys($arr);
	$max_length = count($arr)-1;
	if(($keys[0] == 0) and ($keys[$max_length] == $max_length)) {//See if the first key is 0 and last key is length - 1
		$is_list = true;
		for($i=0; $i<count($keys); $i++) { //See if each key correspondes to its position
			if($i != $keys[$i]) { //A key fails at position check.
				$is_list = false; //It is an associative array.
				break;
			}
		}
	}
	
	foreach($arr as $key=>$value) {
		if(is_array($value)) { //Custom handling for arrays
			if($is_list) $parts[] = array2json($value); /* :RECURSION: */
			else $parts[] = '"' . $key . '":' . array2json($value); /* :RECURSION: */
		} else {
			$str = '';
			if(!$is_list) $str = '"' . $key . '":';
			//Custom handling for multiple data types
			if(is_numeric($value)) $str .= $value; //Numbers
			elseif($value === false) $str .= 'false'; //The booleans
			elseif($value === true) $str .= 'true';
			else $str .= '"' . addslashes($value) . '"'; //All other things
			// :TODO: Is there any more datatype we should be in the lookout for? (Object?)
			$parts[] = $str;
		}
	}
	$json = implode(',',$parts);
	
	if($is_list) return '[' . $json . ']';//Return numerical JSON
	return '{' . $json . '}';//Return associative JSON
}

endif;
?>