<?php

if (!defined('RBF_FUNC_INI')):

define('RBF_FUNC_INI', true);
define('RBF_VERSION', '2.1'); // 2010-03-07
define('RBF_ROOT_PATH', XOOPS_ROOT_PATH.'/Frameworks');

function rb_framework_version()
{
	$version = RBF_VERSION;
	return (float)$version;
}

function rb_load_class($handler = 'crud', $dirname = 'rb')
{
	$handler    = strtolower($handler);
	$className  = 'Rb'.ucfirst($handler).'Handler';
	$fileName   = 'class.'.$handler.'.php'; 
	
	class_exists($className) || require_once RBF_ROOT_PATH.'/'.$dirname.'/'.$fileName;
	return class_exists($className);
}

	function rb_load_object($handler = 'crud', $dirname = 'rb')
	{
		return rb_load_class($handler, $dirname);
	}

function rb_load_functions($group = '', $dirname = 'rb')
{
	$dirname = ('' == $dirname ) ? 'rb' : $dirname;
	$constant = strtoupper('frameworks_'.$dirname.'_functions'.(($group) ? '_'.$group : ''));
	if (defined($constant)) return true;
	return include_once RBF_ROOT_PATH.'/'.$dirname.'/functions.'.$group.(empty($group) ? '' : '.' ).'php';
}

function rb_load_language($handler = 'format', $dirname = 'rb/language')
{
	global $xoopsConfig;
	$language = ($xoopsConfig) ? $xoopsConfig['language'] : 'english';
	$fileName = $handler.'.php';
	if (!@include_once RBF_ROOT_PATH.'/'.$dirname.'/'.$language.'/'.$fileName) {
		include_once RBF_ROOT_PATH.'/'.$dirname.'/english/'.$fileName;
	}
}

// Compatible with XOOPS 2.0.16 or Cube
function rb_need_compatible()
{
	static $ret = NULL;
	if ($ret !== NULL) return $ret;
	
	$ret = (substr(XOOPS_VERSION, 6, 3) > 2.0) ? false : true;
	return $ret;
}

endif;
?>