<?php

if (!defined('RBF_FUNC_USER')):

define('RBF_FUNC_USER', true);

// check permission kernel/groupperm.php
function rb_check_perm($perm_item, $perm_type)
{
	global $xoopsUser, $xoopsModule;	
	$groups = is_object($xoopsUser) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
	$module_id = is_object($xoopsModule) ? $xoopsModule->getVar('mid') : 0;
	
	$gperm_handler =& xoops_gethandler('groupperm');
	$ret = $gperm_handler->checkRight($perm_type, $perm_item, $groups, $module_id);
	return $ret;
}

// get IP
function rb_get_ip()
{
	static $realip = NULL;
	if ($realip !== NULL) return $realip;
	
	if (!rb_need_compatible()) {
		$realip = xoops_getenv('REMOTE_ADDR');
	} else {
		if (isset($_SERVER)) {
			if (isset($_SERVER['HTTP_CLIENT_IP'])) {
				$ip = $_SERVER['HTTP_CLIENT_IP'];
				if(!preg_match("/^(10|172\.16|192\.168)\./i", $ip)) {
					$realip = $ip;
				} else {
					$realip = $_SERVER['REMOTE_ADDR'];
				}
			} elseif (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
				$arr = explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']);
				foreach ($arr AS $ip)
				{
					$ip = trim($ip);
					if ($ip != 'unknown') {
						if(!preg_match("/^(10|172\.16|192\.168)\./i", $ip)) {
							$realip = $ip;
						} else {
							$realip = $_SERVER['REMOTE_ADDR'];
						}
						break;
					}
				}
			} else {
				if (isset($_SERVER['REMOTE_ADDR'])) {
					$realip = $_SERVER['REMOTE_ADDR'];
				} else {
					$realip = '0.0.0.0';
				}
			}
		} else {
			if (getenv('HTTP_CLIENT_IP')) {
				$ip = getenv('HTTP_CLIENT_IP');
				if(!preg_match("/^(10|172\.16|192\.168)\./i", $ip)) {
					$realip = $ip;
				} else {
					$realip = getenv('REMOTE_ADDR');
				}
			} elseif (getenv('HTTP_X_FORWARDED_FOR')) {
				$ip = getenv('HTTP_X_FORWARDED_FOR');
				if(!preg_match("/^(10|172\.16|192\.168)\./i", $ip)) {
					$realip = $ip;
				} else {
					$realip = getenv('REMOTE_ADDR');
				}
			} else {
				$realip = getenv('REMOTE_ADDR');
			}
		}
		preg_match("/[\d\.]{7,15}/", $realip, $onlineip);
		$realip = !empty($onlineip[0]) ? $onlineip[0] : '0.0.0.0';
	}
    return $realip;
}

endif;
?>