<?php

if (!defined('ACP_FUNCTIONS')):
define('ACP_FUNCTIONS', 1);

//@include_once XOOPS_ROOT_PATH.'/Frameworks/rb/functions.php';

function gui_encode($string = '', $protect = true) {
	$string = htmlspecialchars($string);
	if ($protect) {
		$string = base64_encode($string);
		$string = strtr($string, '+/=', '-\*');
	}
	return $string;
}

function gui_decode($string = '', $protect = true) {
	if ($protect) {
		$string = strtr($string, '-\*', '+/=');
		$string = base64_decode($string);
	}
	$string = stripslashes($string);
	return $string;
}

function gui_redirect_header($url, $time = 3, $message = '', $addredirect = true, $allowExternalLink = false)
{
    if (function_exists('redirect_ajax')) {
		return redirect_ajax($url, $time, $message, $addredirect, $allowExternalLink);
	} else {
		return redirect_header($url, $time, $message, $addredirect, $allowExternalLink);
	}
}

function redirect_ajax($url, $time = 3, $message = '', $addredirect = true, $allowExternalLink = false)
{
    global $xoopsConfig;
	
    if ( preg_match( "/[\\0-\\31]|about:|script:/i", $url) ) {
        if (!preg_match('/^\b(java)?script:([\s]*)history\.go\(-[0-9]*\)([\s]*[;]*[\s]*)$/si', $url) ) {
            $url = XOOPS_URL;
        }
    }
	
    if ( !$allowExternalLink && $pos = strpos( $url, '://' ) ) {
        $xoopsLocation = substr( XOOPS_URL, strpos( XOOPS_URL, '://' ) + 3 );
        if (strcasecmp(substr($url, $pos + 3, strlen($xoopsLocation)), $xoopsLocation)) {
            $url = XOOPS_URL;
        }
    }
	
    if (!empty($_SERVER['REQUEST_URI']) && $addredirect && strstr($url, 'user.php')) {
        if (!strstr($url, '?')) {
            $url .= '?xoops_redirect=' . urlencode($_SERVER['REQUEST_URI']);
        } else {
            $url .= '&amp;xoops_redirect=' . urlencode($_SERVER['REQUEST_URI']);
        }
    }
	
    if (defined('SID') && SID && (! isset($_COOKIE[session_name()]) || ($xoopsConfig['use_mysession'] && $xoopsConfig['session_name'] != '' && !isset($_COOKIE[$xoopsConfig['session_name']])))) {
        if (!strstr($url, '?')) {
            $url .= '?' . SID;
        } else {
            $url .= '&amp;' . SID;
        }
    }
	
    $url = preg_replace("/&amp;/i", '&', htmlspecialchars($url, ENT_QUOTES));
    $message = trim($message) != '' ? $message : _TAKINGBACK;
	//$_SESSION['redirect_message'] = $message;
	//$_SESSION['redirect_time'] = $time * 1000;
	setcookie('redirect_message', $message, time() + $time, '/');
	setcookie('redirect_time', $time * 1000, time() + $time, '/');
	header( 'Location: '.preg_replace("/[&]amp;/i",'&', $url) ) ;
    exit();
}
endif;
?>